//  DtL - Derive to LaTeX by Gary Bishop 29 June 1999

static char rcsid[] = "$Id: main.cpp,v 1.1 1999-07-01 11:03:09-04 gb Exp gb $";

#include <stdio.h>
#include <getopt.h>
#include "DtL.h"
#include "Str.h"

extern int yyparse();

DataPort DataRead = DP_Clipboard;
DataPort DataWrite = DP_Clipboard;

Str LeftString = "\\[\n";
Str RightString = "\\]\n";

int KeepComments = 1;

void usage()
{
  fprintf(stderr, "usage: DtL [-fFdk] [-l beginning-string] [-r ending-string]\n");
  fprintf(stderr, "  with no arguments DtL reads a \"DfW Expression\" from the clipboard\n");
  fprintf(stderr, "  and writes the equivalent LaTeX back to the clipboard as text\n");
  fprintf(stderr, "  -f says read from stdin\n");
  fprintf(stderr, "  -F says write to stdout\n");
  fprintf(stderr, "  -d turns on debugging prints\n");
  fprintf(stderr, "  -k toggles printing of the comments\n");
  fprintf(stderr, "  -l \"string\" replaces the default \"\\[\" to open math mode in LaTeX\n");
  fprintf(stderr, "  -r \"string\" replaces the default \"\\]\" to close math mode\n");
}

int main(int argc, char* argv[])
{
  int c;
  while((c = getopt(argc, argv, "cCfFdkl:r:")) != -1)
    switch(c)
      {
      case 'c':
	DataRead = DP_Clipboard;
	break;
      case 'C':
	DataWrite = DP_Clipboard;
	break;
      case 'f':
	DataRead = DP_File;
	break;
      case 'F':
	DataWrite = DP_File;
	break;
      case 'd':
	yydebug = 1;
	break;
      case 'l':
	LeftString = optarg;
	break;
      case 'r':
	RightString = optarg;
	break;
      case 'k':
	KeepComments = !KeepComments;
	break;
      default:
	usage();
	exit(1);
      }
  init_io();

  if(yyparse()) {
    //fprintf(stderr, "parse failed\n");
  } else {
    //fprintf(stderr, "ok\n");
  }
  return 0;
}

void yyerror(char* s)
{
    fprintf(stderr, "Syntax error on line %d\n", lineno);
}

